using System;
using System.Collections.Generic;

public class CustomerManager : ICustomerManager
{
	private SortedList<int, ICustomer> customers;
    private SortedList<int, IOrder> orders;

    private int nextIndex = 1;
    private static int nextOrderId = 1;

	public CustomerManager()
	{
		customers = new SortedList<int, ICustomer>();
        orders = new SortedList<int,IOrder>();
	}

	public ICustomer AddCustomer(string name)
	{
		Customer customer =  new Customer(name);
        customers.Add(nextIndex, customer);
        customer.Id = nextIndex;
        nextIndex++;
        return customer;
	}

    public void AddOrderForCustomer(ICustomer customer, IList<string> items)
    {
        Order order = new Order(nextOrderId, items);
        nextOrderId++;

        Customer cust = customer as Customer;
        cust.CurrentOrder = order;
    }

	public void RemoveCustomer(ICustomer customer)
	{
        customers.Remove(customer.Id);
	}

	public ICustomer GetCustomer(string name)
	{
        ICustomer customer = null;

        foreach (KeyValuePair<int, ICustomer> pair in customers)
        {
            if (pair.Value.Name == name)
            {
                customer = pair.Value;
                break;
            }
        }

		return customer;
	}

	public ICustomer GetCustomer(int id)
	{
        ICustomer customer = null;
        customers.TryGetValue(id, out customer);
        return customer;
	}

	public IList<ICustomer> GetCustomers()
	{
        List<ICustomer> list = new List<ICustomer>();

        foreach (KeyValuePair<int, ICustomer> pair in customers)
            list.Add(pair.Value);
            
		return list;
	}
}

