﻿using System;
using System.Collections.Generic;

public class CustomerDataMapper : ICustomerDataMapper
{
    private static SortedList<int, Customer> customers = new SortedList<int,Customer>();
    private static SortedList<int, Order> orders = new SortedList<int, Order>();

    private static int nextIndex = 1;
    private static int nextOrderId = 1;

    public void Delete(ICustomer customer)
    {
        if (customer.CurrentOrder != null)
            orders.Remove(customer.CurrentOrder.OrderId);

        customers.Remove(customer.Id);
    }

    public IList<ICustomer> GetCustomers(IList<int> ids)
    {
        List<ICustomer> list = new List<ICustomer>();

        if (ids == null)
        {
            foreach (KeyValuePair<int, Customer> pair in customers)
                list.Add(pair.Value);
        }
        else
        {
            foreach (int id in ids)
            {
                foreach (KeyValuePair<int, Customer> pair in customers)
                {
                    if (pair.Key == id)
                        list.Add(pair.Value);
                }
            }
        }
            
		return list;
    }

    public void Save(ICustomer customer)
    {
        Customer cust = null;
        Order order = null;
        bool found;
        
        found = customers.TryGetValue(customer.Id, out cust);
        if (found == false)
        {
            order = null;
            if (customer.CurrentOrder != null)
            {
                order = new Order(nextOrderId, customer.CurrentOrder.Items);
                orders.Add(nextOrderId, order);
                nextOrderId++;
            }

            cust = new Customer(customer.Name, order);
            cust.Id = nextIndex;
            customers.Add(nextIndex, cust);
            nextIndex++;
        }
        else
        {
            cust.Name = customer.Name;

            order = null;
            if (cust.CurrentOrder != null)
            {
                int orderId = cust.CurrentOrder.OrderId;
                found = orders.TryGetValue(orderId, out order);
                if (found == false)
                {
                    order = new Order(nextOrderId, cust.CurrentOrder.Items);
                    nextOrderId++;
                    cust.CurrentOrder = order;
                }
                else
                {
                    order.OrderId = orderId;
                    order.Items = cust.CurrentOrder.Items;
                }
            }
        }


    }
}

