using System;
using System.Collections.Generic;

public class CustomerManager : ICustomerManager
{
    ICustomerDataMapper dm = null;

    public CustomerManager(ICustomerDataMapper dm)
	{
        this.dm = dm;
	}

	public ICustomer AddCustomer(string name)
	{
        Customer customer = new Customer(name, null);
        dm.Save(customer);

        ICustomer cust = GetCustomer(name);
        return cust;
	}

    public void AddOrderForCustomer(ICustomer customer, IList<string> items)
    {
        Order order = new Order(0, items);
        Customer cust = customer as Customer;
        cust.CurrentOrder = order;

        dm.Save(cust);
    }

	public void RemoveCustomer(ICustomer customer)
	{
        dm.Delete(customer);
	}

	public ICustomer GetCustomer(string name)
	{
        ICustomer customer = null;

        IList<ICustomer> list = dm.GetCustomers(null);

        foreach (ICustomer cust in list)
        {
            if (cust.Name == name)
            {
                customer = cust;
                return customer;
            }
        }

        return null;   
	}

	public ICustomer GetCustomer(int id)
	{
        List<int> list = new List<int>();
        list.Add(id);
        IList<ICustomer> returnList = dm.GetCustomers(list);

        if (returnList.Count == 0)
            return null;
        else
            return returnList[0];
	}

	public IList<ICustomer> GetCustomers()
	{
        IList<ICustomer> list = dm.GetCustomers(null);
		return list;
	}
}

