using System;
using System.Collections.Generic;

public class CustomerManager : ICustomerManager
{
    ICustomerDataMapper dm = null;
    CustomerRepository cr = null;

	public CustomerManager(ICustomerDataMapper dm)
	{
        this.dm = dm;
        cr = new CustomerRepository(dm);
	}

	public ICustomer AddCustomer(string name)
	{
        Customer customer = new Customer(name, null);
        dm.Save(customer);

        ICustomer cust = GetCustomer(name);
        return cust;
	}

    public void AddOrderForCustomer(ICustomer customer, IList<string> items)
    {
        Order order = new Order(0, items);
        Customer cust = customer as Customer;
        cust.CurrentOrder = order;

        dm.Save(cust);
    }

	public void RemoveCustomer(ICustomer customer)
	{
        dm.Delete(customer);
	}

	public ICustomer GetCustomer(string name)
	{
        Criteria criteria = new Criteria();
        criteria.Operator = "Name";
        criteria.Operand = name;

        IList<ICustomer> list = cr.Query(criteria);
        if (list == null)
            return null;

        return list[0];
	}

	public ICustomer GetCustomer(int id)
	{
        Criteria criteria = new Criteria();
        criteria.Operator = "Id";
        criteria.Operand = id;

        IList<ICustomer> list = cr.Query(criteria);
        if (list == null)
            return null;

        return list[0];
	}

	public IList<ICustomer> GetCustomers()
	{
        Criteria criteria = new Criteria();
        criteria.Operator = "All";
        criteria.Operand = null;

        IList<ICustomer> list = cr.Query(criteria);
		return list;
	}
}

